"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MDXContent;
var _react = _interopRequireDefault(require("react"));
var _react2 = require("@mdx-js/react");
var _excluded = ["components"]; // @ts-nocheck
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
/* @jsxRuntime classic */
/* @jsx mdx */

var layoutProps = {};
var MDXLayout = "wrapper";
function MDXContent(_ref) {
  var components = _ref.components,
    props = _objectWithoutProperties(_ref, _excluded);
  return (0, _react2.mdx)(MDXLayout, _extends({}, layoutProps, props, {
    components: components,
    mdxType: "MDXLayout"
  }), (0, _react2.mdx)("h2", null, "Workspace Configuration"), (0, _react2.mdx)("p", null, "The compiler is configured inside an environment and not directly on the component level."), (0, _react2.mdx)("h3", null, "As a task"), (0, _react2.mdx)("p", null, "A task is running with ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit build"), " or during the tag process on the capsules or the workspace (depends on the specific compiler implementation)."), (0, _react2.mdx)("p", null, "The env extension should have this compiler extension as a dependency first, then add to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getBuildPipe()"), " array the following: ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "this.compiler.createTask()"), "."), (0, _react2.mdx)("h3", null, "As a command"), (0, _react2.mdx)("p", null, "A command is running on the workspace."), (0, _react2.mdx)("p", null, "To run: ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit compile"), "."), (0, _react2.mdx)("p", null, "An example of configuring a compiler in the React env."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-jsx"
  }, "/**\n * returns a component compiler.\n */\ngetCompiler(): Compiler {\n  // eslint-disable-next-line global-require\n  const tsConfig = require('./typescript/tsconfig.json');\n  return this.ts.createCompiler(tsConfig);\n}\n")), (0, _react2.mdx)("h2", null, "Compiler Implementation"), (0, _react2.mdx)("p", null, "The compiler is responsible for two processes:"), (0, _react2.mdx)("h3", null, "compile during development"), (0, _react2.mdx)("p", null, "This compilation takes place on the workspace and the dists are saved inside the component dir.\nThe provider should implement ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "transpileFile"), " function as follows:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-jsx"
  }, "transpileFile: (fileContent: string, options: { componentDir: string, filePath: string }) => Array<{ outputText: string, outputPath: string }> | null;\n")), (0, _react2.mdx)("p", null, "In case the compiler receives an unsupported file, it should return null."), (0, _react2.mdx)("h3", null, "compile for build (during the tag command)"), (0, _react2.mdx)("p", null, "This compilation takes place on the isolated capsule.\nThe provider should implement ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "build"), " function which returns the exit-code and the dist dir.\nFrom Compiler interface:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-jsx"
  }, "build(context: BuildContext): Promise<BuildResults>;\n")), (0, _react2.mdx)("h2", null, "Points to consider when writing a compiler"), (0, _react2.mdx)("h3", null, "Debugging experience on the workspace"), (0, _react2.mdx)("p", null, "Since the dists are written into the node_modules/component-name/dist-dir, the debugger needs to know where to find the source files. This can be easily achieved by setting the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "sourceRoot"), " of the source-map file to the component-dir. As a reminder, this directory is passed to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "transpile()"), " method."), (0, _react2.mdx)("h3", null, "Error handling during build process"), (0, _react2.mdx)("p", null, "Without proper error handling, the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "build()"), " will exit an the first error found. Catch the errors and add them to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "ComponentResult.errors[]"), " you return per component."));
}
;
MDXContent.isMDXComponent = true;

//# sourceMappingURL=compiler.mdx.js.map